import java.io.BufferedWriter;
import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;

public class ReseauFilesAttentes {
    private int temps;
    private int nbServeurs;
    private double q;
    private double p;
    private double lambda;
    private double mu;
    private ArrayList<Double> tempsEntree;
    private ArrayList<Double> tempsSortie;

    public static ArrayList<Double> traitement = new ArrayList<>();

    public ReseauFilesAttentes(int temps,int nbServeurs,double lambda,double mu){
        this.temps = temps;
        this.nbServeurs = nbServeurs;
        this.q = 1.0/nbServeurs;
        this.p = 1.0/nbServeurs;
        this.lambda = lambda;
        this.mu = mu;
        this.tempsEntree = new ArrayList<>();
        this.tempsSortie = new ArrayList<>();
    }

    public double getLambda(){
        return this.lambda;
    }

    public double getMu(){
        return this.mu;
    }

    public static double equation4(double l) {
        double r = Math.random();
        return -Math.log(1-r)/l;//dans combien de temps,un nouveau requete arrive
    }

    public static void enregistrerLesDonnees(String filename, String partieNom, String contenu) {
        try {
            String filepath = System.getProperty("user.dir") + File.separator + "data/" + filename
                    + String.valueOf(partieNom) + ".dat";
            System.out.println("Ecriture du fichier : " + filepath);
            FileWriter fw = new FileWriter(filepath);
            BufferedWriter bw = new BufferedWriter(fw);
            bw.write(contenu);
            bw.close();
        } catch ( IOException e) {
            e.printStackTrace();
        }
    }

    public void lesDonnees(){
        String contenuEntree = "";
        String contenuSortie = "";
        double x=0;
        int y=0;
        double leTempsTraitement;
        while (x<=this.temps)
        {
            x=x+equation4(this.getLambda());
            tempsEntree.add(x);
            contenuEntree+=y+" "+x+"\n";
            if(y==0){
                traitement.add(y,tempsEntree.get(y));
                //le temps sortie égale au temps Entree+le temps Traitement(equation4(mu))
                leTempsTraitement = equation4(this.getMu());
                tempsSortie.add(y,traitement.get(y)+leTempsTraitement);
            }else{
                leTempsTraitement = equation4(this.getMu());
                if(tempsSortie.get(y-1)<tempsEntree.get(y))
                    tempsSortie.add(y,tempsEntree.get(y)+leTempsTraitement);
                else
                    tempsSortie.add(y,tempsSortie.get(y-1)+leTempsTraitement);
            }
            contenuSortie+=y+" "+tempsSortie.get(y)+"\n";
            y++;
        }
        enregistrerLesDonnees("entree", String.valueOf(this.getLambda())+"_"+String.valueOf(this.getMu()),contenuEntree);
        enregistrerLesDonnees("sortie", String.valueOf(this.getLambda())+"_"+String.valueOf(this.getMu()),contenuSortie);
    }

    public boolean isConvergence(){
        if(this.getLambda()/this.getMu()<1) return true;
        else return false;//le systèm n'arrete pas,c'est un systèm infini
    }

    public static void main(String[] args) {
        ReseauFilesAttentes rfa = new ReseauFilesAttentes(10000,2,0.5,1.0);
        System.out.println("**************************************");
        System.out.println("le système converge? "+rfa.isConvergence());
        rfa.lesDonnees();

    }
}
